// Constructor of base class is called with derived

#include <iostream>
using namespace std;

class Base
{
    int x; // Remember, classes default to private
    public:
        Base(){cout << "Base default constructor" << endl;}
};

class Derived: public Base
{
    int y;
    public:
        Derived(){cout << "Derived default constr" << endl;}

        Derived(int i)
        {
            y = i;
            cout << "Derived parameterized" << endl;
        }
};

int main()
{
    cout << "Base b; results in: " << endl;
    Base b; //  Base...

    cout << endl << "Derived d1; results in: " << endl;
    Derived d1; //  Base...

    cout << endl << "Derived d2(10); results in: " << endl;
    Derived d2(10); //  Base...

    return 0;
}
